/**
 \file 		hashing_includes.h
 \author 	michael.zohner@ec-spride.de
 \copyright	ABY - A Framework for Efficient Mixed-protocol Secure Two-party Computation
			Copyright (C) 2019 Engineering Cryptographic Protocols Group, TU Darmstadt
			This program is free software: you can redistribute it and/or modify
            it under the terms of the GNU Lesser General Public License as published
            by the Free Software Foundation, either version 3 of the License, or
            (at your option) any later version.
            ABY is distributed in the hope that it will be useful,
            but WITHOUT ANY WARRANTY; without even the implied warranty of
            MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
            GNU Lesser General Public License for more details.
            You should have received a copy of the GNU Lesser General Public License
            along with this program. If not, see <http://www.gnu.org/licenses/>.
 \brief		Header file that is used to point to the correct path of crypto.h and typedefs.h
 	 	    needed by the hashing repository in hashing/
 */

#ifndef HASHING_INCLUDES_H_
#define HASHING_INCLUDES_H_

#include <ENCRYPTO_utils/typedefs.h>
#include <ENCRYPTO_utils/utils.h>
#include <ENCRYPTO_utils/crypto/crypto.h>

#endif /* HASHING_INCLUDES_H_ */
